-- =============================================
-- SaveToDB Framework for Microsoft SQL Server
-- Version 7.19, March 12, 2018
--
-- Copyright 2015-2018 Gartle Technology Corporation
-- =============================================

-- The query drops objects of the SaveToDB Framework

IF OBJECT_ID('savetodb_dev.view_query_list_tools', 'V') IS NOT NULL
DROP VIEW savetodb_dev.view_query_list_tools
GO

IF OBJECT_ID('savetodb_etl.usp_update_event_handlers', 'P') IS NOT NULL
DROP PROCEDURE savetodb_etl.usp_update_event_handlers
GO
IF OBJECT_ID('savetodb_etl.view_event_handlers_suggest', 'V') IS NOT NULL
DROP VIEW savetodb_etl.view_event_handlers_suggest
GO

IF OBJECT_ID('savetodb_etl.view_object_translation_suggest', 'V') IS NOT NULL
DROP VIEW savetodb_etl.view_object_translation_suggest
GO

IF OBJECT_ID('savetodb_etl.usp_generate_change_handler', 'P') IS NOT NULL
DROP PROCEDURE savetodb_etl.usp_generate_change_handler
GO
IF OBJECT_ID('savetodb_etl.usp_generate_edit_procedures', 'P') IS NOT NULL
DROP PROCEDURE savetodb_etl.usp_generate_edit_procedures
GO
IF OBJECT_ID('savetodb_etl.usp_generate_genegic_handler', 'P') IS NOT NULL
DROP PROCEDURE savetodb_etl.usp_generate_genegic_handler
GO

DROP PROCEDURE savetodb_etl.usp_update_column_translation
GO
DROP PROCEDURE savetodb_etl.usp_update_column_translation_group
GO
DROP PROCEDURE savetodb_etl.usp_update_object_translation
GO
DROP PROCEDURE savetodb_etl.usp_update_object_translation_absent
GO
DROP PROCEDURE savetodb_dev.usp_update_table_format
GO

DROP VIEW savetodb_xls.view_event_handlers
GO
DROP VIEW savetodb_xls.view_table_formats
GO
DROP VIEW savetodb_xls.view_parameter_values
GO
DROP VIEW savetodb_xls.view_query_list
GO
DROP VIEW savetodb_xls.view_column_translation
GO
DROP VIEW savetodb_xls.view_object_translation
GO
DROP VIEW savetodb_xls.view_object_description
GO
DROP VIEW savetodb_dev.view_query_list
GO

DROP TABLE savetodb_dev.event_handlers
GO
DROP TABLE savetodb_dev.table_formats
GO
DROP TABLE savetodb_dev.column_translation
GO
DROP TABLE savetodb_dev.object_translation
GO
DROP TABLE savetodb_dev.parameter_values
GO
DROP TABLE savetodb_dev.query_list
GO

DECLARE @sql nvarchar(max)

SELECT @sql = ( 
    SELECT
        'ALTER ROLE ' + QUOTENAME(p.name) + ' DROP MEMBER ' + QUOTENAME(m.name) + ';' + CHAR(10)
    FROM
        sys.database_role_members rm
        INNER JOIN sys.database_principals p ON p.principal_id = rm.role_principal_id
        INNER JOIN sys.database_principals m ON m.principal_id = rm.member_principal_id
    WHERE
        p.name IN ('savetodb_dev_role', 'savetodb_xls_role')
    FOR XML PATH('')
    )

EXEC (@sql)

PRINT @sql
GO

DROP ROLE savetodb_dev_role
GO
DROP ROLE savetodb_xls_role
GO

DROP SCHEMA savetodb_dev
GO
DROP SCHEMA savetodb_etl
GO
DROP SCHEMA savetodb_xls
GO

print N'SaveToDB Framework has been dropped';
GO
